#include <stdio.h>


int main(int argc, char** argv){

/*  <stdio.h>
	
	FILES
		fopen 		(abre y crea un archivo en disco)
		fclose 		(cierra un archivo que se ha abierto)
		feof 		(evalúa fin de archivo - End Of File)
		rewind 		(sitúa el cursor de lectura/escritura al principio del archivo)
		fseek 		(sitúa el cursor del archivo a un punto arbitrario)
	READ
		fgetc 		(lee un caracter a la vez de un archivo)
		fgets 		(lee cadenas de caracteres de un archivo)
		fread 		(lee un bloque de una "stream" de datos)
		fscanf 		(funciona igual que scanf, pero tomando un archivo)
	WRITE
		fputc 		(escribe un carácter a la vez en un archivo)
		fputs		(escribe una cadena de caractéres en un archivo)
		fwrite 		(escribie hacia un archivo)
		fprintf     (igual que printf, pero escribe en un archivo)
*/

	if (argc !=2){
		printf("ERROR! Cantidad de argumentos inválida.\n");
		return -1;
	}
	
	FILE *f = NULL;

	/*
	 * Con "r" abrirmos el archivo para leer
	 * Con "w" creamos un archivo para escribir, descartamos contenido anterior
	 * Con "a" creamos un archivo para escribir, escribimos al final del archivo
	 * Con "r+" abrimos un archivo como lectura y escritura
	 * Con "w+" abrimos un archivo como lectura y escrtura, descartamos el contenido anterior
	 * Con "a+" abrimos un archivo como lectura y escritura, comenzamos a escribir al final del archivo
	 */

	// FILE *fopen(const char *filename, const char *mode)

	f = fopen(argv[1], "w+");
	if (f==NULL){
		printf("ERROR! No se pudo abrir el archivo.\n");
		return -2;
	}

	/*	
	 * Salida de caracter: fputc, fputs, putc
	 */
	
	putc('P',f);
	putc('r',f);
	putc('o',f);
	putc('b',f);
	fputc('a',f);	
	fputs("ndo fputs, putc y fputc!\n", f);
	fclose(f);
	
	/*
	 * Entrada de caracter: fgetc, fgets, getc
	 */
	
	f = fopen(argv[1], "r");
	if (f==NULL){
		printf("ERROR! No se pudo abrir el archivo.\n");
		return -2;
	}
    
    char t[10];
    
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	
	printf("%s",fgets(t, 10, f));
	printf("%c",getc(f));
	

	//Posicionamiento en los arhivos: fseek

	printf("\nVolvemos para atrás\n");
	fseek(f,-15,SEEK_CUR);	
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%s",fgets(t, 10, f));
	printf("%c",getc(f));
	
	//Posicionamiento en los arhivos: rewind
	printf("\nVolvemos para atras nuevamente\n");
	rewind(f);
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%c",fgetc(f));
	printf("%s",fgets(t, 10, f));
	printf("%c",getc(f));
     	
	//Posicionamiento en los arhivos: rewind
	printf("\nVolvemos para atras nuevamente\n");
	rewind(f);
	int c;
	c = fgetc(f);
	while ( c != EOF ){
		printf("%c",c);
		c = fgetc(f);
	}
	fclose(f);
}